/*
 * Copyright (C) 2010  Axel Kesseler
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
#pragma once

#include "string.h"

namespace plexdata
{
	namespace autoplay
	{
		class CBrowser
		{
			HWND                      m_hParent;
			plexdata::string::CString m_sURL;
			HICON                     m_hIcon;
			int                       m_nTop;
			int                       m_nLeft;
			int                       m_nHeight;
			int                       m_nWidth;
			bool                      m_bResizable;
			bool                      m_bToolBar;
			bool                      m_bAddressBar;
			bool                      m_bMenuBar;
			bool                      m_bStatusBar;

		public:

			CBrowser();

			virtual ~CBrowser();

		public:

			bool LaunchBrowser
				( HWND                       hParent 
				, plexdata::string::CString& sURL
				, HICON                      hIcon
				, int                        nTop
				, int                        nLeft
				, int                        nHeight
				, int                        nWidth
				, bool                       bResizable  = false
				, bool                       bToolBar    = false
				, bool                       bAddressBar = false
				, bool                       bMenuBar    = false
				, bool                       bStatusBar  = false
				);

		private:

			static DWORD WINAPI StartBrowser
				( LPVOID pParameter 
				);

		};
	}
}