/*
 * Copyright (C) 2010  Axel Kesseler
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
#pragma once

#include "configuration.h"
#include "button.h"

namespace plexdata
{
	namespace autoplay
	{
		class CDialog
		{
		private:

			static const int WELCOME_LINES;
			static const int WELCOME_HEADER;
			static const int WELCOME_MARGIN;
			static const int BUTTON_MARGIN;
			static const int BUTTON_ID_BASE;

		private:

			HWND          m_hDialog;
			HBRUSH        m_hBkBrush;
			HFONT         m_hFont;
			CButton*      m_pButtons;
			int           m_nFormat;
			volatile bool m_bExecuting;
			volatile bool m_bClosing;

		public:

			CDialog();

			virtual ~CDialog();

		public:

			bool Initialize();

			int  Show( int nCmdShow=SW_SHOWNORMAL );

		private:

			static INT_PTR CALLBACK DialogProc( HWND hDialog, UINT uMsg, WPARAM wParam, LPARAM lParam );
			static INT_PTR CALLBACK AboutHandler( HWND hAbout, UINT uMsg, WPARAM wParam, LPARAM lParam );

		private:

			void OnInitDialog( HWND hDialog );
			void OnPaint( HDC hdcTarget );
			void OnClose();
			void OnButtonClick( int nButtonID, HWND hButton );
			bool OnSysCommand( int nCommandID, int nAdditional );
			void OnInitMenuPopup( HMENU hMenu, unsigned int nIndex, bool bSystemMenu );

		private:

			void AdjustBorderStyle( HWND hDialog );

			RECT CalcWelcomeRectangle( HWND hDialog, HFONT hFont, int nFormat );

			void ExecuteButton( CButtonData* pBtnData );

			bool LaunchProcess( const TCHAR* szCommandLine, bool bWait );

		};
	}
}